package com.base.scanqr.ui.wifi

import android.os.Environment
import androidx.activity.addCallback
import androidx.core.view.updatePadding
import androidx.lifecycle.ViewModelProvider
import com.base.scanqr.R
import com.base.scanqr.ads.AdsMgr
import com.base.scanqr.ads.AdsShowCallBack
import com.base.scanqr.base.BaseActivity
import com.base.scanqr.bean.FunctionUIBean
import com.base.scanqr.bean.WifiUIBean
import com.base.scanqr.bean.WifiUIBean.Companion.createWifiQRString
import com.base.scanqr.databinding.ActivityWifiCodeBinding
import com.base.scanqr.ui.vm.QrViewModel
import com.base.scanqr.ui.widget.InputNameDialog.showInputNameDialog
import com.base.scanqr.utils.BarUtils
import com.base.scanqr.utils.BitmapUtils.saveBitmapToFile
import com.base.scanqr.utils.ClipboardUtils.copyText
import com.base.scanqr.utils.IntentUtils.intentShareImage
import com.base.scanqr.utils.IntentUtils.intentWifiSettings
import com.base.scanqr.utils.LogEx
import com.base.scanqr.utils.QRCodeUtils.generateQRCode
import com.base.scanqr.utils.SpJsonUtils
import com.base.scanqr.utils.ToastUtils.toast
import com.google.gson.Gson
import com.gyf.immersionbar.ktx.immersionBar
import java.io.File

class WifiCodeActivity : BaseActivity<ActivityWifiCodeBinding>(ActivityWifiCodeBinding::inflate) {

    private var wifiBean: WifiUIBean = WifiUIBean()
    private var qrString: String = ""
    private var tempImagePath: String = ""
    private val viewModel by lazy(LazyThreadSafetyMode.NONE) {
        ViewModelProvider(this)[QrViewModel::class.java]
    }


    override fun onResumeOneShoot() {
        super.onResumeOneShoot()
        val flag = changeLanguage()
        if (flag) return

        AdsMgr.showBanner(binding.flBanner, false)
    }

    override fun initView() {
        super.initView()
        binding.clTop.updatePadding(top = BarUtils.getStatusBarHeight())
        AdsMgr.showNative(binding.flAd, R.layout.layout_admob_item)

        val data = intent.extras?.getString("data")
        LogEx.logDebug(TAG, "data=$data")
        data?.let {
            wifiBean = Gson().fromJson(data, WifiUIBean::class.java)
            if (wifiBean.securityId == 0) {
                binding.tvSecurity.text = "WPA/WPA2"
            }
            if (wifiBean.securityId == 1) {
                binding.tvSecurity.text = "WEP"
            }
            binding.tvSsid.text = wifiBean.ssid
            binding.tvPassword.text = wifiBean.password
            if (wifiBean.hidden) {
                binding.tvHidden.text = "YES"
            } else {
                binding.tvHidden.text = "NO"
            }

            qrString = createWifiQRString(wifiBean)
            LogEx.logDebug(TAG, "wifiContent=$qrString")
        }

        Thread {
            val bitmap = generateQRCode(qrString, 735, 735, 5)
            runOnUiThread {
                binding.ivQr.setImageBitmap(bitmap)
                val file = File(cacheDir, System.currentTimeMillis().toString() + ".jpg")
                bitmap?.let {

                    val flag = saveBitmapToFile(it, file.absolutePath)
                    LogEx.logDebug(TAG, "flag=$flag tempImage=${file.absolutePath}")
                    if (flag) {
                        tempImagePath = file.absolutePath
                    }
                }
                if (wifiBean.needCreate) {
                    wifiBean.needCreate = false
                    SpJsonUtils.addJsonBean<WifiUIBean>(FunctionUIBean.KEY_WIFI, wifiBean)
                }
            }
        }.start()

    }

    override fun initListener() {
        super.initListener()
        onBackPressedDispatcher.addCallback {
            AdsMgr.showInsert(this@WifiCodeActivity, false, object : AdsShowCallBack() {
                override fun close(where: Int) {
                    finishToMainTop()
                }

                override fun failed(where: Int) {
                    finishToMainTop()

                }

                override fun googleFailed(where: Int) {
                    finishToMainTop()
                }
            })
        }
        binding.flBack.setOnClickListener {
            onBackPressedDispatcher.onBackPressed()
        }
        binding.llShare.setOnClickListener {
            val intent = intentShareImage(this, tempImagePath)
            runCatching {
                startActivity(intent)
            }
        }
        binding.llPdf.setOnClickListener {
            toast("没有做")
        }
        binding.llDownload.setOnClickListener {
            kotlin.runCatching {
                val newName = File(tempImagePath).name
                showInputNameDialog(newName) { name ->
                    viewModel.copyFileToDownloads(this, name, tempImagePath)
                }
            }
        }
        binding.llCopy.setOnClickListener {
            copyText(TAG, qrString)
            toast("Copied to clipboard", true)
        }
        binding.flSearch.setOnClickListener {
            val wifiIntent = intentWifiSettings()
            kotlin.runCatching {
                startActivity(wifiIntent)
            }
        }
    }

    override fun configSystemBar() {
        immersionBar {
            statusBarColor("#FFFFFFFF")
            statusBarDarkFont(true)
        }
    }

}